package isac.session;

import isac.interfaces.IToGUI;
import isac.users.UserManager;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

/**
 * RK for watching RMI between WindowApplication and ObjectManager
 * during work on problems 0702 with RMI at htl
 * @see constructor for ObjectManager
 * @see isac.util.FixedPortRMISocketFactory
 * @see isac.util.WindowApplicationRMISocketFactory
 */
public class WatchdogThread extends Thread {

	public void run() {
		while (true) {
			try {
				HashMap hm = SessionManager.getInstance().getSessionMap();
				ArrayList<Session> sessions = new ArrayList<Session>(hm
						.values());
				System.out.println("WatchdogDEBUG before:"+SessionManager.getInstance().getSessionMap().size());
				for (int count = 0; count < sessions.size(); count++) {
					try {
					    Session session = sessions.get(count);
					    IToGUI toGUI = session.getIToGUI();
					    if (toGUI != null) {
						if (!toGUI.isUIRunning()) {
						    UserManager.getInstance().logout(session);
						}
					    }
					} catch (RemoteException e) {
						UserManager.getInstance().logout(sessions.get(count));
					}

				}
				System.out.println("WatchdogDEBUG after:"+SessionManager.getInstance().getSessionMap().size());
				Thread.sleep(300000);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

}
