(* attempts to perserve binary minus as wanted by Austrian teachers
   WN071207
   (c) due to copyright terms
remove_thy"PolyMinus";
use_thy_only"IsacKnowledge/PolyMinus";
use_thy"IsacKnowledge/Isac";
*)

PolyMinus = (*Poly// due to "is_ratpolyexp"..*) Rational + 

consts

  (*predicates for conditions in rewriting*)
  kleiner     :: "['a, 'a] => bool" 	("_ kleiner _") 
  ist'_monom  :: "'a => bool"		("_ ist'_monom")

  (*the CAS-command*)
  Probe       :: "[bool, bool list] => bool"  
	(*"Probe (3*a+2*b+a = 4*a+2*b) [a=1,b=2]"*)

  (*descriptions for the pbl and met*)
  Pruefe      :: bool => una
  mitWert     :: bool list => tobooll
  Geprueft    :: bool => una

  (*Script-name*)
  ProbeScript :: "[bool, bool list,       bool] \
				      \=> bool"
                  ("((Script ProbeScript (_ _ =))// (_))" 9)

rules

  tausche_plus		"[| a kleiner b; b ist_monom |] ==> (b + a) = (a + b)"
  tausche_minus		"[| a kleiner b; b ist_monom |] ==> (b - a) = (-a + b)"
  tausche_plus_plus	"b kleiner c ==> (a + c + b) = (a + b + c)"
  tausche_plus_minus	"b kleiner c ==> (a + c - b) = (a - b + c)"
  tausche_minus_plus	"b kleiner c ==> (a - c + b) = (a + b - c)"
  tausche_minus_minus	"b kleiner c ==> (a - c - b) = (a - b - c)"

  addiere_x_plus_minus	 "[| l is_const; m is_const |] ==>  \
			 \(k + m * n) - l * n = k + (m - l) * n"
  addiere_x_minus_plus   "[| l is_const; m is_const |] ==>  \
			 \(k - m * n) + l * n = k + (-m + l) * n"
  addiere_x_minus_minus  "[| l is_const; m is_const |] ==>  \
			 \(k - m * n) - l * n = k + (-m - l) * n"

  vorzeichen_minus_weg1  "l kleiner 0 ==> a + l * b = a - -1*l * b"
  vorzeichen_minus_weg2  "l kleiner 0 ==> a - l * b = a + -1*l * b"
  vorzeichen_minus_weg3  "l kleiner 0 ==> k + a - l * b = k + a + -1*l * b"
  vorzeichen_minus_weg4  "l kleiner 0 ==> k - a - l * b = k - a + -1*l * b"

  (*klammer_plus_plus = (real_add_assoc RS sym)*)
  klammer_plus_minus     "a + (b - c) = (a + b) - c"
  klammer_minus_plus     "a - (b + c) = (a - b) - c"
  klammer_minus_minus    "a - (b - c) = (a - b) + c"

end

