/*==============================================================*/
/* Database name:  userlogger                                   */
/* DBMS name:      MySQL 5.0                                    */
/* Created on:     30.07.2007 13:05:24                          */
/*==============================================================*/


drop database if exists userlogger;

/*==============================================================*/
/* Database: userlogger                                         */
/*==============================================================*/
create database userlogger;

use userlogger;

/*==============================================================*/
/* User: isac                                                   */
/*==============================================================*/
create user isac identified by 'isac';

/*==============================================================*/
/* Table: UserLogger                                            */
/*==============================================================*/
create table UserLogger
(
   UserLogger_id        int not null auto_increment,
   UserName             varchar(25) not null,
   Session              varchar(25) not null,
   Dialog               varchar(50),
   Step                 varchar(50),
   Time                 timestamp not null default CURRENT_TIMESTAMP,
   Worksheet            varchar(250),
   Position             varchar(50),
   FormulaFrom          text,
   FormulaTo            text,
   Argument             varchar(250),
   Substitution         varchar(250),
   Success              float,
   primary key (UserLogger_id)
);

/*==============================================================*/
/* Index: Idx_UserLogger_01                                     */
/*==============================================================*/
create index Idx_UserLogger_01 on UserLogger
(
   Session
);

/*==============================================================*/
/* Index: Idx_UserLogger_02                                     */
/*==============================================================*/
create index Idx_UserLogger_02 on UserLogger
(
   UserName
);

/*==============================================================*/
/* Index: Idx_UserLogger_03                                     */
/*==============================================================*/
create index Idx_UserLogger_03 on UserLogger
(
   Worksheet
);

/*==============================================================*/
/* Table: UserTest                                              */
/*==============================================================*/
create table UserTest
(
   UserTest_id          int not null auto_increment,
   TestValue            varchar(25) not null,
   primary key (UserTest_id)
);

/*==============================================================*/
/* Index: Idx_Test_01                                           */
/*==============================================================*/
create index Idx_Test_01 on UserTest
(
   TestValue
);

